/*
 * This program does the same operation as an MPI_Bcast() but
 * does it using MPI_Send() and MPI_Recv(). 
 */
#include <mpi.h>
#include <iostream>
using namespace std;

int main(int argc, char **argv)
{
    int nprocs;           /* the number of processes in the task */
    int myrank;           /* my rank */
    int i;
    int l      = 0;
    int tag    = 42;      /* tag used for all communication */
    int tag2   = 99;      /* extra tag used for what ever you want */ 
    int data   = 0;       /* initialize all the data buffers to 0 */
    MPI_Status status;    /* status of MPI_Recv() operation */
  
    MPI_Init(&argc, &argv);

    MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
    MPI_Comm_size(MPI_COMM_WORLD, &nprocs);

    /* Initialize the data for rank 0 process only. */
    if (myrank == 0) {
        data = 399;
    }

    if (myrank == 0) {
        for (i = 1; i < nprocs; i++) {
            MPI_Send(&data, 1, MPI_BYTE, i, tag, MPI_COMM_WORLD);
       }
    }
    else {
        MPI_Recv(&data-1, l, MPI_INT, 0, tag2, MPI_COMM_WORLD, &status);
    }

    MPI_Barrier(MPI_COMM_WORLD);

    /* Check the data everywhere. */
    if (data != 399) 
    {
        cerr <<"Whoa!  The data is incorrect"<<endl;
    }

    return 0;
}
    
