! This program does the same operation as an call MPI_Bcast() but
! does it using call MPI_Send() and call MPI_Recv().  .

program main

    implicit none
    include "mpif.h"

    integer :: nprocs;       ! the number of processes in the task 
    integer :: myrank;         ! my rank 
    integer :: i, ierr;
    integer :: l      = 0;
    integer :: tag    = 42;  ! tag used for all communication 
    integer :: tag2   = 99;  ! extra tag used for what ever you want  
    integer :: data(2) = 0;  ! initialize all the data buffers to 0 
    integer status(MPI_STATUS_SIZE); ! status of call MPI_Recv() operation

    call MPI_Init(ierr);

    call MPI_Comm_rank(MPI_COMM_WORLD, myrank, ierr);
    call MPI_Comm_size(MPI_COMM_WORLD, nprocs, ierr);

    ! Initialize the data for rank 0 process only.
    if (myrank == 0) then
        data(1) = 399;
    end if


    if (myrank == 0) then
        do i = 1, nprocs - 1 
            call MPI_Send(data(1), 1, MPI_BYTE, i, tag, MPI_COMM_WORLD, ierr);
        end do
    else
        call MPI_Recv(data(2), l, MPI_INTEGER, 0, tag2, MPI_COMM_WORLD, status, ierr);
    end if

    call MPI_Barrier(MPI_COMM_WORLD, ierr);

    ! Check the data everywhere.
    if (data(1) /= 399) then
        write(*,*) "Whoa!  The data is incorrect"
    else
        write(*,*) "Data sent and received successfully"
    end if

end program main

